import tensorflow as tf
import pickle
import sys
import tensorflow.keras
import os
import numpy as np
from tensorflow.keras import datasets, layers, models
import matplotlib.pyplot as plt
from tensorflow.keras.layers import Dense, Dropout, Activation, Flatten
# from tensorflow.keras.utils.np_utils import *
from tensorflow.keras.optimizers import SGD
from tensorflow.keras.models import Model
from tensorflow.keras.models import load_model

Q = {}

for i in ['glorot_normal__1','glorot_normal__2','glorot_normal__3','glorot_uniform__1','glorot_uniform__2','glorot_uniform__3'
    ,'randomnormal_mean0_sttddev_1_1024_1.5__1','randomnormal_mean0_sttddev_1_1024_1.5__2','randomnormal_mean0_sttddev_1_1024_1.5__3'
    ,'randomnormal_mean0_sttddev_1_1024_2__1','randomnormal_mean0_sttddev_1_1024_2__2','randomnormal_mean0_sttddev_1_1024_2__3'
    ,'randomnormal_mean0_sttddev_1_10240__1','randomnormal_mean0_sttddev_1_10240__2','randomnormal_mean0_sttddev_1_10240__3'
    ,'randomnormal_mean0_sttddev_2_1024+512__1','randomnormal_mean0_sttddev_2_1024+512__2','randomnormal_mean0_sttddev_2_1024+512__3'
    ,'randomnormal_mean0_sttddev_sqrt_2_1024+512__1','randomnormal_mean0_sttddev_sqrt_2_1024+512__2','randomnormal_mean0_sttddev_sqrt_2_1024+512__3']:

    path=r'E:\deep_study\20210824_condense_review\for_review_20210824\fitnd\%s\objs.pkl'%i   #path='/root/……/aus_openface.pkl'   pkl文件所在路径
	   
    with open(path,'rb') as f: 
        R = pickle.load(f)
    
    Q[i] = R['history_val_acc']
print(R.keys())
plt.figure()
plt.rcParams['savefig.dpi'] = 300 #图片像素
plt.rcParams['figure.dpi'] = 300 #分辨率
for i in ['glorot_normal__2','glorot_normal__3','glorot_uniform__1','glorot_uniform__2','glorot_uniform__3'
    ,'randomnormal_mean0_sttddev_sqrt_2_1024+512__1','randomnormal_mean0_sttddev_sqrt_2_1024+512__2','randomnormal_mean0_sttddev_sqrt_2_1024+512__3']:
    plt.plot(Q[i], linewidth=1.0, linestyle='-', color='red') 
    # print(Q[i][-1])
plt.plot(Q['glorot_normal__1'], linewidth=0.5,label = 'common', linestyle='-', color='red')
# print(Q['glorot_normal__1'][-1])

for i in ['randomnormal_mean0_sttddev_1_1024_1.5__2','randomnormal_mean0_sttddev_1_1024_1.5__3'
    ,'randomnormal_mean0_sttddev_1_1024_2__1','randomnormal_mean0_sttddev_1_1024_2__2','randomnormal_mean0_sttddev_1_1024_2__3'
    # ,'randomnormal_mean0_sttddev_1_10240__1','randomnormal_mean0_sttddev_1_10240__2','randomnormal_mean0_sttddev_1_10240__3'
    ,'randomnormal_mean0_sttddev_2_1024+512__1','randomnormal_mean0_sttddev_2_1024+512__2','randomnormal_mean0_sttddev_2_1024+512__3'
    ]:
    plt.plot(Q[i], linewidth=1.0, linestyle='--', color='green') 
    print(Q[i][-1])
plt.plot(Q['randomnormal_mean0_sttddev_1_1024_1.5__1'], linewidth=0.5,label = 'condensed', linestyle='--', color='green')
print(Q['randomnormal_mean0_sttddev_1_1024_1.5__1'][-1])
plt.xlabel(r'epoch',fontsize=22)
plt.ylabel(r'acc',rotation=0,fontsize=22)
plt.tick_params(axis='both',which='major',labelsize=16)
plt.legend(fontsize=16)
plt.tight_layout()
plt.savefig(r'E:\deep_study\20210824_condense_review\for_review_20210824/val_acc.png')
plt.close()

for i in ['glorot_normal__1','glorot_normal__2','glorot_normal__3','glorot_uniform__1','glorot_uniform__2','glorot_uniform__3'
    ,'randomnormal_mean0_sttddev_1_1024_1.5__1','randomnormal_mean0_sttddev_1_1024_1.5__2','randomnormal_mean0_sttddev_1_1024_1.5__3'
    ,'randomnormal_mean0_sttddev_1_1024_2__1','randomnormal_mean0_sttddev_1_1024_2__2','randomnormal_mean0_sttddev_1_1024_2__3'
    ,'randomnormal_mean0_sttddev_1_10240__1','randomnormal_mean0_sttddev_1_10240__2','randomnormal_mean0_sttddev_1_10240__3'
    ,'randomnormal_mean0_sttddev_2_1024+512__1','randomnormal_mean0_sttddev_2_1024+512__2','randomnormal_mean0_sttddev_2_1024+512__3'
    ,'randomnormal_mean0_sttddev_sqrt_2_1024+512__1','randomnormal_mean0_sttddev_sqrt_2_1024+512__2','randomnormal_mean0_sttddev_sqrt_2_1024+512__3']:

    path=r'E:\deep_study\20210824_condense_review\for_review_20210824\fitnd\%s\objs.pkl'%i   #path='/root/……/aus_openface.pkl'   pkl文件所在路径
	   
    with open(path,'rb') as f: 
        R = pickle.load(f)

    Q[i] = R['history_train_acc']

plt.figure()
plt.rcParams['savefig.dpi'] = 300 #图片像素
plt.rcParams['figure.dpi'] = 300 #分辨率
for i in ['glorot_normal__2','glorot_normal__3','glorot_uniform__1','glorot_uniform__2','glorot_uniform__3'
    ,'randomnormal_mean0_sttddev_sqrt_2_1024+512__1','randomnormal_mean0_sttddev_sqrt_2_1024+512__2','randomnormal_mean0_sttddev_sqrt_2_1024+512__3']:
    plt.plot(Q[i], linewidth=1.0, linestyle='-', color='red') 
    # print(Q[i][-1])
plt.plot(Q['glorot_normal__1'], linewidth=0.5,label = 'common', linestyle='-', color='red')
# print(Q['glorot_normal__1'][-1])

for i in ['randomnormal_mean0_sttddev_1_1024_1.5__2','randomnormal_mean0_sttddev_1_1024_1.5__3'
    ,'randomnormal_mean0_sttddev_1_1024_2__1','randomnormal_mean0_sttddev_1_1024_2__2','randomnormal_mean0_sttddev_1_1024_2__3'
    # ,'randomnormal_mean0_sttddev_1_10240__1','randomnormal_mean0_sttddev_1_10240__2','randomnormal_mean0_sttddev_1_10240__3'
    ,'randomnormal_mean0_sttddev_2_1024+512__1','randomnormal_mean0_sttddev_2_1024+512__2','randomnormal_mean0_sttddev_2_1024+512__3'
    ]:
    plt.plot(Q[i], linewidth=1.0, linestyle='--', color='green') 
    print(Q[i][-1])
plt.plot(Q['randomnormal_mean0_sttddev_1_1024_1.5__1'], linewidth=0.5,label = 'condensed', linestyle='--', color='green')
print(Q['randomnormal_mean0_sttddev_1_1024_1.5__1'][-1])
plt.xlabel(r'epoch',fontsize=22)
plt.ylabel(r'acc',rotation=0,fontsize=22)
plt.tick_params(axis='both',which='major',labelsize=16)
plt.legend(fontsize=16)
plt.tight_layout()
plt.savefig(r'E:\deep_study\20210824_condense_review\for_review_20210824/train_acc.png')
plt.close()
